<template>
  <div class="review">
    <label>Rating: {{ review.rating }} / 5</label>
    <star-rating :rating="review.rating"></star-rating>
    <label v-if="review.posterData">By {{ review.posterData.name }}</label>
    <label><strong>Visited at {{ getFormattedDate(review.date) }}</strong></label>
    <p>{{ review.comment }}</p>
    <div v-if="review.reply" class="review-reply">
      <label><strong>Reply by restaurant owner</strong></label>
      <p>{{ review.reply }}</p>
    </div>
    <dynamic-form
    v-on:success="createReviewReplySuccessful"
    buttonText="Post Reply"
    :endpointUrl="'/api/reviews/' + review._id + '/reply'"
    endpointType="post"
    :fields="[
      {
        name: 'reply',
        label: 'Reply',
        type: 'textarea',
        required: true,
      }
    ]"
    v-if="(!review.reply && user.role == 'owner')">
    </dynamic-form>
    <dynamic-form
    v-on:success="editReviewSuccessful"
    headerText="Edit Review"
    buttonText="Submit Changes"
    :endpointUrl="'/api/reviews/' + review._id"
    endpointType="put"
    v-if="edit"
    :fields="editReviewFields">
    </dynamic-form>
    <span class="edit-delete-buttons" v-if="user.role == 'admin'">
      <input type="button"
      :disabled="edit"
      class="edit-button"
      v-on:click="editReview()"
      value="Edit review">
      <input type="button"
      class="delete-button"
      v-on:click="deleteReview()"
      value="Delete review">
    </span>
    <div class="loading-spinner-overlay" v-if="loading"></div>
  </div>
</template>

<script>
import dynamicForm from './DynamicForm.vue';
import starRating from './StarRating.vue';
import store from '../store/index';
import { mapState } from 'vuex';
import moment from 'moment';
import axios from 'axios';
import { proxy } from '../config/proxy';

export default {
  computed: {
    ...mapState([
      'user',
    ]),
    editReviewFields() {
      let fields = [
        {
          name: 'comment',
          label: 'Comment',
          type: 'textarea',
          required: true,
          value: this.review.comment,
        },
        {
          name: 'date',
          label: 'Date',
          type: 'date',
          required: true,
          value: this.getFormattedDate(this.review.date),
        },
        {
          name: 'rating',
          label: 'Rating',
          type: 'dropdown',
          required: true,
          value: this.review.rating,
          options: [
            {
              value: 1,
              label: '1 - Abysmal',
            },
            {
              value: 2,
              label: '2 - Meh',
            },
            {
              value: 3,
              label: '3 - Alright',
            },
            {
              value: 4,
              label: '4 - Splendid',
            },
            {
              value: 5,
              label: '5 - Exceptional',
            },
          ],
        },
      ];
      if (this.review.reply) {
        fields.push({
          name: 'reply',
          label: 'Reply',
          type: 'textarea',
          required: true,
          value: this.review.reply,
        });
      }
      return fields;
    },
  },
  props: {
    review: Object,
  },
  data() {
    return {
      edit: false,
      loading: false,
    };
  },
  components: {
    dynamicForm,
    starRating,
  },
  methods: {
    getFormattedDate(date) {
      return moment(date).format('YYYY-MM-DD');
    },
    deleteReview() {
      // toggle loading spinner on
      this.loading = true;
      // http request
      axios.delete(proxy + '/api/reviews/' + this.review._id).then((response) => {
        // remove review in the frontend
        store.commit('deleteReviewSuccessful', {
          review: response.data,
        });
        // toggle loading spinner off
        this.loading = false;
      }).catch((error) => {
        // log error message
        console.log({ error: error.message });
        // toggle loading spinner off
        this.loading = false;
      });
    },
    createReviewReplySuccessful(response) {
      // create review reply successful
      store.commit('createReviewReplySuccessful', {
        reply: response.data.reply,
        review: this.review,
      });
    },
    editReview() {
      this.edit = true;
    },
    editReviewSuccessful(response) {
      this.edit = false;
      store.commit('editReviewSuccessful', {
        review: response.data,
      });
    },
  },
}
</script>

<style lang="scss">
.review {
  position: relative;
  overflow: hidden;
  background: #0001;
  padding: 10px;
  border-radius: 5px;
  margin-top: 10px;
  .review-reply {
    background: #0001;
    padding: 10px;
    border-radius: 5px;
  }
  label, p {
    margin-bottom: 10px;
  }
}
</style>
